#include "Image.h"

Image::Image() {
    npx = npy = npix = 0;
    data = 0;
}

Image::Image(double* array, int n, int m) {
    data = new double[n*m];
    for (int j = 0; j < n; j++) {
	for (int i = 0; i < m; i++) {
	    data[i+j*m] = array[i+j*m];
	} 
    }
    npx = m;
    npy = n;
    npix = n * m;
}

Image::~Image() {
    delete [] data;
}

int Image::getNpx() const {
    return npx;
}

int Image::getNpy() const {
    return npy;
}

int Image::getNpix() const {
    return npix;
}

void Image::getNaxis(int *npx, int *npy) {
    *npx = this->npx;
    *npy = this->npy;
}

double Image::getValue(int x, int y) const {
    return data[x+npx*y];
}
