import pyfits
import ds9
import Image

def getArray(img):
    array = img.getData(img.getNpix())
    array.shape = (img.getNpy(), img.getNpx())
    return array

def display(img, d=None):
    if (d == None):
        ds9_targets = ds9.ds9_targets()
        if  ds9_targets == None:
            d = ds9.ds9()
        else:
            d = ds9.ds9(ds9_targets[0].split()[1])
    array = getArray(img)
    cmd = "array [ydim=%d,xdim=%d,bitpix=-32]" % (array.shape)
    d.set(cmd, array)

def readFits(name):
    hdulist = pyfits.open(name)
    img = Image.Image(hdulist[0].data)
    hdulist.close()
    return img

def writeFits(name, img):
    array = getArray(img)
    hdu = pyfits.PrimaryHDU(array)
    hdulist = pyfits.HDUList([hdu])
    hdulist.writeto(name, clobber=True)
    
filelist = []
file = open('filelist')
for line in file.readlines():
    filelist.append(line.strip())
file.close

imglist = Image.ImageVector()
for file in filelist:
    print file
    img = readFits(file)

    median = img.median()

    img /= median

    imglist.push_back(img)

flat = Image.Image_getMedian(imglist)

display(flat)

writeFits("flat.fits", flat)
