import pyfits
import ds9
import Image

def getArray(img):
    array = img.getData(img.getNpix())
    array.shape = (img.getNpy(), img.getNpx())
    return array

def display(img, d=None):
    if (d == None):
        ds9_targets = ds9.ds9_targets()
        if  ds9_targets == None:
            d = ds9.ds9()
        else:
            d = ds9.ds9(ds9_targets[0].split()[1])
    array = getArray(img)
    cmd = "array [ydim=%d,xdim=%d,bitpix=-32]" % (array.shape)
    d.set(cmd, array)

filelist = []
file = open('filelist')
for line in file.readlines():
    filelist.append(line.strip())
file.close

for file in filelist:
    hdulist = pyfits.open(file)
    prihdr = hdulist[0].header
    npx = prihdr['NAXIS1']
    npy = prihdr['NAXIS2']
    min1 = prihdr['EFP-MIN1']
    rng1 = prihdr['EFP-RNG1']
    min2 = prihdr['EFP-MIN2']
    rng2 = prihdr['EFP-RNG2']
    filter = prihdr['FILTER01']
    img = Image.Image(hdulist[0].data)
    hdulist.close()
    if (min1 == 1):
        osimg = img.crop(min1+rng1-1, min2-1, npx-(min1+rng1), rng2)
        os = osimg.median()
    else:
        osimg = img.crop(0, 0, min1-1, rng2)
        os = osimg.median()

    file = file.split('/')[2]
    print "%s %s %4d %4d %4d %4d %4d" % (file, filter, min1, rng1, min2, rng2, os)

    img -= os

    efimg = img.crop(min1-1+4, min2-1+4, rng1-8, rng2-8)

    #display(efimg)

    array = getArray(efimg)
    hdu = pyfits.PrimaryHDU(array)
    hdu.header = prihdr
    hdu.scale('int16', '', bzero=32768)
    hdu.header.add_comment("Subtracted bias value of %d" % (os))
    hdu.header.add_comment("Croped from (%d, %d)" % (min1+4, min2+4))
    hdulist = pyfits.HDUList([hdu])
    hdulist.writeto(file, clobber=True)
